/**
******************************************************************************
* @file    delay.c
* @author  xiao chen
* @version V1.3
* @date    16/11/2023
* @brief   This file provides all the delay firmware functions.
******************************************************************************
* @copy
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, HOLOCENE SHALL NOT BE HELD LIABLE FOR ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
* <h2><center>&copy; COPYRIGHT 2023 HOLOCENE</center></h2>
*/

#include "delay.h"
//////////////////////////////////////////////////////////////////////////////////

static u8  fac_us = 0;							//usʱ
static u16 fac_ms = 0;							//msʱ,ucos,ÿĵms
extern u32 TK499_SYS_CLK;


//ʼӳٺ
//SYSTICKʱӹ̶ΪHCLKʱӵ1/8
//SYSCLK:ϵͳʱ
void delay_init()
{
    SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);	//ѡⲿʱ  HCLK/8
    fac_us = TK499_SYS_CLK / 8000000;				//Ϊϵͳʱӵ1/8
    fac_ms = (u16)fac_us * 1000;					//OS,ÿmsҪsystickʱ
}


//ʱnus
//nusΪҪʱus.
void delay_us(u32 nus)
{
    u32 temp;
    SysTick->LOAD = nus * fac_us; 					//ʱ
    SysTick->VAL = 0x00;        					//ռ
    SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk ;	//ʼ
    do
    {
        temp = SysTick->CTRL;
    }
    while((temp & 0x01) && !(temp & (1 << 16)));		//ȴʱ䵽
    SysTick->CTRL &= ~SysTick_CTRL_ENABLE_Msk;	//رռ
    SysTick->VAL = 0X00;      					 //ռ
}
//ʱnms
//עnmsķΧ
//SysTick->LOADΪ24λĴ,,ʱΪ:
//nms<=0xffffff*8*1000/SYSCLK
//SYSCLKλΪHz,nmsλΪms
//240M,ʱnms<=559Ҫʱ500mSӶһ
void delay_ms(u16 nms)
{
    u32 temp;
    SysTick->LOAD = (u32)nms * fac_ms;				//ʱ(SysTick->LOADΪ24bit)
    SysTick->VAL = 0x00;							//ռ
    SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk ;	//ʼ
    do
    {
        temp = SysTick->CTRL;
    }
    while((temp & 0x01) && !(temp & (1 << 16)));		//ȴʱ䵽
    SysTick->CTRL &= ~SysTick_CTRL_ENABLE_Msk;	//رռ
    SysTick->VAL = 0X00;       					//ռ
}


/**
* @}
*/

/**
* @}
*/

/**
* @}
*/

/*-------------------------(C) COPYRIGHT 2023 HOLOCENE ----------------------*/






































